<?php
/**
 * DLE Shikimori
 *
 * @copyright 2018 PunPun (https://punpun.name)
 * @version   1.0.0
 * @link      https://punpun.name
 */

@error_reporting(E_ALL ^ E_WARNING ^ E_NOTICE);
@ini_set('display_errors', true);
@ini_set('html_errors', false);
@ini_set('error_reporting', E_ALL ^ E_WARNING ^ E_NOTICE);

define('DATALIFEENGINE', true);
define('ROOT_DIR', '.');
define('ENGINE_DIR', ROOT_DIR . '/engine');

include ENGINE_DIR . '/data/config.php';
require_once ENGINE_DIR . '/classes/mysql.php';
require_once ENGINE_DIR . '/data/dbconfig.php';

$charset = 'utf8';
$filec = explode(DIRECTORY_SEPARATOR, __FILE__);
$thisFile = end($filec);

$action = (isset($_GET['action'])) ? strip_tags($_GET['action']) : 'main';

$install_config = array(
	'module' => 'dle_shikimori',
	'version' => '1.0.0',
	'dle_ver' => '12.0 - 13.x',
	'date' => '27.08.2018',
	'language' => array(
		'Установка модуля',
		'DLE Shikimori',
		'Поддержка модуля',
		'Выполнить запросы в базу данных',
		'Управление настройками',
		'от',
	),
	'install' => array(
		'title' => 'Установка успешно завершена.',
		'descr' => 'Не забудьте удалить файл установки <code>' . $thisFile . '</code>.',
	),
);

$page = <<<HTML
<p style="text-align:center;">Этот файл выполнит запросы в базу данных для корректной работы модуля DLE Shikimori. Если вы столкнулись с какой-то проблемой, пожалуйста, свяжитесь со мной. Так же вы можете отблагодарить автора материально - <a href="https://punpun.name/portfolio/64-dle-shikimori.html" target="_blank">https://punpun.name/portfolio/64-dle-shikimori.html</a></p>
<div class="of_page">
	<a href="/dle_shikimori_install.php?action=install" style="background:#6fa951">{$install_config['language'][3]}</a>
</div>
HTML;

if ($action == 'install') {
	$dataBase = [];
    $dataBase[] = "DELETE FROM `{PREFIX}_admin_sections` WHERE `name`='{$install_config['module']}'";
	$dataBase[] = "INSERT INTO `{PREFIX}_admin_sections` (`name`, `title`, `descr`, `icon`, `allow_groups`) VALUES ('{$install_config['module']}', '{$install_config['language'][1]}', '{$install_config['language'][4]}', '{$install_config['module']}.png', '1')";
	foreach ($dataBase as $dataQuery){
		$db->query(str_replace(array('{PREFIX}', '{CHAR}'), array(PREFIX, $charset), $dataQuery));
	}

$page =<<<HTML
<div class="result">{$install_config[$action]['title']}</div>
<div class="descr">{$install_config[$action]['descr']}</div>
<div class="of_page">
	<a href="/{$config['admin_path']}?mod=dle_shikimori" style="background:#467fcf">{$install_config['language'][4]}</a>
</div>
HTML;
}

echo <<<HTML
<!DOCTYPE HTML>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset={$config['charset']}" />
		<title>{$install_config['language'][0]} {$install_config['language'][1]}</title>
		<style>html,body{font:13px/18px Arial,Helvetica,sans-serif;color:#333;background:#748490;margin:0;padding:0}code,pre{font-family:Menlo,Monaco,Consolas,"Courier New",monospace}code{padding:2px 4px;font-size:90%;color:#c7254e;background-color:#f9f2f4;white-space:nowrap;border-radius:4px}pre,ol li textarea{display:block;padding:10px;margin:5px 0 10.5px;font-size:14px;line-height:1.42857143;word-break:break-all;word-wrap:break-word;color:#303030;background-color:#ebebeb;border:1px solid #ccc}pre code{padding:0;font-size:inherit;color:inherit;white-space:pre-wrap;background-color:transparent;border-radius:0}.pre-scrollable{max-height:340px;overflow-y:scroll}.label{display:inline;padding:.2em .6em .3em;font-size:75%;line-height:1;color:#fff;text-align:center;white-space:nowrap;vertical-align:baseline;border-radius:.25em}.label[href]:hover,.label[href]:focus{color:#fff;text-decoration:none;cursor:pointer}.label:empty{display:none}.btn .label{position:relative;top:-1px}.label-default{background-color:#464545}.label-default[href]:hover,.label-default[href]:focus{background-color:#2c2c2c}.label-primary{background-color:#375a7f}.label-primary[href]:hover,.label-primary[href]:focus{background-color:#28415b}.label-success{background-color:#00bc8c}.label-success[href]:hover,.label-success[href]:focus{background-color:#008966}.label-info{background-color:#238DB1}.label-info[href]:hover,.label-info[href]:focus{background-color:#217dbb}.label-warning{background-color:#f39c12}.label-warning[href]:hover,.label-warning[href]:focus{background-color:#c87f0a}.label-danger{background-color:#e74c3c}.label-danger[href]:hover,.label-danger[href]:focus{background-color:#d62c1a}.wrapper{width:800px;overflow:hidden;margin:2% auto;-webkit-box-shadow:rgba(0,0,0,0.3) 0 1px 3px;-moz-box-shadow:rgba(0,0,0,0.3) 0 1px 3px;box-shadow:rgba(0,0,0,0.3) 0 1px 3px;border-color:#E5E5E5 #DBDBDB #D2D2D2;background:#FFF;position:relative}.wrapper .cms{position:absolute;top:0;font-size:18px;right:0;padding:5px 10px;color:#fff;background-color:#03a9f4;}.wrapper .date{position:absolute;top:0;font-size:13px;left:0;padding:5px 10px;font-style:italic;color:#fff;background-color:#03a9f4}.wrapper .result{margin-top:10px}.wrapper .of_page{margin:15px 0;text-align:center}.wrapper .of_page a{text-decoration:none;color:#787878;background:#D77E47;color:#fff;padding:5px 10px}ol li{margin:0;padding:10px 0;border-bottom:1px solid #ebebeb}ol li textarea{width:100%;background-color:#ebebeb;outline:none;border:1px solid #ccc;height:auto;padding:5px}header{background:#334E61;padding:15px}header .title{color:#fff;text-align:center}header .title sup,header .title sub{display:block}header .title sup{font-size:28pt;font-weight:700;line-height:40pt}header .title sub{font-size:14px}section{padding:30px}footer{background:#E5E5E5;padding:5px 15px}table{max-width:100%;background-color:transparent;border-spacing:0;width:100%;margin-bottom:20px;border:1px solid #ddd;border-collapse:separate;*border-collapse:collapse;border-left:0}table th,table td{padding:8px;line-height:20px;vertical-align:top;border-top:1px solid #ddd;border-left:1px solid #ddd}table td a{color:#4C6589}table th{font-weight:700;color:#4C6589}table thead th{vertical-align:bottom}table caption + thead tr:first-child th,table caption + thead tr:first-child td,table colgroup + thead tr:first-child th,table colgroup + thead tr:first-child td,table thead:first-child tr:first-child th,table thead:first-child tr:first-child td{border-top:0}table caption + thead tr:first-child th,table caption + tbody tr:first-child th,table caption + tbody tr:first-child td,table colgroup + thead tr:first-child th,table colgroup + tbody tr:first-child th,table colgroup + tbody tr:first-child td,table thead:first-child tr:first-child th,table tbody:first-child tr:first-child th,table tbody:first-child tr:first-child td{border-top:0}table tbody tr:hover > td,table tbody tr:hover > th{background-color:#f5f5f5}table tbody tr.success > td{background-color:#dff0d8}table tbody tr.error > td{background-color:#f2dede}table tbody tr.warning > td{background-color:#fcf8e3}table tbody tr.info > td{background-color:#d9edf7}
		.wrapper .result { margin-top: 10px; text-align: center; font-size: 18px;}
		.wrapper .descr { margin-top: 10px; text-align: center; font-size: 14px;}
		</style>
	</head>
	<body>
		<div class="wrapper">
			<header>
				<div class="title">
					<sup>{$install_config['language'][1]} {$install_config['version']}</sup>
					<sub>{$install_config['language'][0]}</sub>
				</div>
				<div class="cms">DLE <b>{$install_config['dle_ver']}</b></div>
				<div class="date">{$install_config['language'][11]} <span>{$install_config['date']}</span></div>
			</header>
			<section>{$page}</section>
			<footer>
				<div class="of_page"><a href="https://punpun.name/" target="_blank">{$install_config['language'][2]}</a></div>
			</footer>
		</div>
	</body>
</html>
HTML;
?>