<?php
/**
 * DLE Shikimori
 *
 * @copyright 2018 PunPun (https://punpun.name)
 * @version   1.0.0
 * @link      https://punpun.name
 */

@error_reporting(E_ALL ^ E_WARNING ^ E_DEPRECATED ^ E_NOTICE);
@ini_set('error_reporting', E_ALL ^ E_WARNING ^ E_DEPRECATED ^ E_NOTICE);
@ini_set('display_errors', true);
@ini_set('html_errors', false);

define('DATALIFEENGINE', true);
define('ROOT_DIR', substr(dirname(__FILE__), 0, -37));
define('ENGINE_DIR', ROOT_DIR . '/engine');

$is_logged = false;
if (file_exists(ENGINE_DIR . '/classes/plugins.class.php')) {
	require_once (ENGINE_DIR . '/classes/plugins.class.php');
	include_once (DLEPlugins::Check(ENGINE_DIR . '/inc/include/functions.inc.php'));

	dle_session();
	require_once (DLEPlugins::Check(ENGINE_DIR . '/modules/sitelogin.php'));
	include_once (DLEPlugins::Check(ENGINE_DIR . '/classes/thumb.class.php'));
} else {
	include ENGINE_DIR . '/data/config.php';
	require_once ENGINE_DIR . '/classes/mysql.php';
	require_once ENGINE_DIR . '/data/dbconfig.php';
	require_once ENGINE_DIR . '/inc/include/functions.inc.php';

	dle_session();
	require_once ENGINE_DIR . '/modules/sitelogin.php';
	include_once ENGINE_DIR . '/classes/thumb.class.php';
}

include ENGINE_DIR . '/mod_punpun/dle_shikimori/language/dle_shikimori.lng';
@header("Content-type: text/html; charset=" . $config['charset']);

date_default_timezone_set($config['date_adjust']);
$_TIME = time();

if (!$is_logged || $member_id['user_group'] != 1) {
	echo json_encode(['error' => $dle_shikimori_lang[46]]);
	return;
}

//################# Определение групп пользователей
$user_group = get_vars('usergroup');
if(!$user_group) {
	$user_group = array();
	$db->query("SELECT * FROM " . USERPREFIX . "_usergroups ORDER BY id ASC");
	while($row = $db->get_row()) {
		$user_group[$row['id']] = array();
		foreach($row as $key => $value)
			$user_group[$row['id']][$key] = stripslashes($value);
	}
	set_vars('usergroup', $user_group);
	$db->free();
}

//################# Определение категорий и их параметры
$cat_info = get_vars('category');
if(!is_array($cat_info)) {
	$cat_info = array();
	$db->query("SELECT * FROM " . PREFIX . "_category ORDER BY posi ASC");
	while($row = $db->get_row()) {
		$cat_info[$row['id']] = array();
		foreach($row as $key => $value)
			$cat_info[$row['id']][$key] = stripslashes($value);
	}
	set_vars('category', $cat_info);
	$db->free();
}

$action = isset($_POST['action']) ? trim($_POST['action']) : false;
include ENGINE_DIR . '/mod_punpun/dle_shikimori/config/dle_shikimori.php';
include ENGINE_DIR . '/mod_punpun/dle_shikimori/helpers/Shikimori.php';
if ($action == 'search') {
	$name = isset($_POST['name']) ? trim(strip_tags(stripslashes($_POST['name']))) : false;
	if (!$name) {
		echo json_encode(['error' => $dle_shikimori_lang[45]]);
		return;
	} else {
		$result = $dleShikimori->searchAnime($name);
		echo json_encode($result);
	}
} elseif ($action == 'parse') {
	$id = isset($_POST['id']) ? trim(strip_tags(stripslashes($_POST['id']))) : false;
	$newsId = intval($_POST['newsId']) > 0 ? intval($_POST['newsId']) : 0;
	if (!$id) {
		echo json_encode(['error' => $dle_shikimori_lang[47]]);
		return;
	} else {
		$result = $dleShikimori->parseAnime($id);
		echo json_encode($result);
	}
}
?>